function handleClickEnDe(info, tab) {
	translate(info, tab, 'ende');
}

function handleClickFrDe(info, tab) {
	translate(info, tab, 'frde');
}

function handleClickEsDe(info, tab) {
	translate(info, tab, 'esde');
}

function handleClickItDe(info, tab) {
	translate(info, tab, 'itde');
}

function handleClickZhDe(info, tab) {
	translate(info, tab, 'chde');
}

function handleClickRuDe(info, tab) {
	translate(info, tab, 'rude');
}

function handleClickPtDe(info, tab) {
	translate(info, tab, 'ptde');
}

function handleClickPlDe(info, tab) {
	translate(info, tab, 'plde');
}

function translate(info, tab, lp) {
	var baseURL = "https://dict.leo.org/";
	chrome.storage.local.get({
		language: 'de',
		searchBehaviour: 2,
		reUseTabOrWindow: 1
	}, function (items) {
		baseURL += getDictionaryPath(items.language, lp);
		
		baseURL += "/" + info.selectionText;
		
		if (items.searchBehaviour == 0) {
			if (items.reUseTabOrWindow == 1) {
				window.open(baseURL, "leoOrgExtension_ResultWindow");
			}
			else {
				window.open(baseURL);
			}
		}
		
		if (items.searchBehaviour == 1) {
			chrome.tabs.create({ url: baseURL });
		}
	});
}

function getDictionaryPath(lang, lp) {
	switch (lp) {
		case "ende":
			switch (lang) {
				case "en":
					return "german-english";
				default:
					return "englisch-deutsch";
			}
		case "frde":
			switch (lang) {
				case "fr":
					return "allemand-français";
				default:
					return "französisch-deutsch";
			}
		case "esde":
			switch (lang) {
				case "es":
					return "alemán-español";
				default:
					return "spanisch-deutsch";
			}
		case "itde":
			switch (lang) {
				case "it":
					return "tedesco-italiano";
				default:
					return "italienisch-deutsch";
			}
		case "chde":
			switch (lang) {
				case "ch":
					return "德语-汉语";
				default:
					return "chinesisch-deutsch";
			}
		case "rude":
			switch (lang) {
				case "ch":
					return "неме́цкий-ру́сский";
				default:
					return "russisch-deutsch";
			}
		case "ptde":
			switch (lang) {
				case "pt":
					return "alemão-português";
				default:
					return "portugiesisch-deutsch";
			}
		case "plde":
			switch (lang) {
				case "pl":
					return "niemiecki-polski";
				default:
					return "polnisch-deutsch";
			}
	}
}

var count = 0;
var title;
var prefEnDe;
var prefFrDe;
var prefEsDe;
var prefItDe;
var prefZhDe;
var prefRuDe;
var prefPtDe;
var prefPlDe;
chrome.storage.local.get({
	prefEnDe: true,
	prefFrDe: true,
	prefEsDe: true,
	prefItDe: true,
	prefZhDe: true,
	prefRuDe: true,
	prefPtDe: true,
	prefPlDe: true
}, function (items) {
	if (items.prefEnDe) {
		title = chrome.i18n.getMessage('leoOrgExt_ende_label');
		prefEnDe = items.prefEnDe;
		count++;
	}
	if (items.prefFrDe) {
		title = chrome.i18n.getMessage('leoOrgExt_frde_label');
		prefFrDe = items.prefFrDe;
		count++;
	}
	if (items.prefEsDe) {
		title = chrome.i18n.getMessage('leoOrgExt_esde_label');
		prefEsDe = items.prefEsDe;
		count++;
	}
	if (items.prefItDe) {
		title = chrome.i18n.getMessage('leoOrgExt_itde_label');
		prefItDe = items.prefItDe;
		count++;
	}
	if (items.prefZhDe) {
		title = chrome.i18n.getMessage('leoOrgExt_zhde_label');
		prefZhDe = items.prefZhDe;
		count++;
	}
	if (items.prefRuDe) {
		title = chrome.i18n.getMessage('leoOrgExt_rude_label');
		prefRuDe = items.prefRuDe;
		count++;
	}
	if (items.prefPtDe) {
		title = chrome.i18n.getMessage('leoOrgExt_ptde_label');
		prefPtDe = items.prefPtDe;
		count++;
	}
	if (items.prefPlDe) {
		title = chrome.i18n.getMessage('leoOrgExt_plde_label');
		prefPlDe = items.prefPlDe;
		count++;
	}
	var leoContextMenu;
	if (count == 1) {
		 leoContextMenu = chrome.contextMenus.create({
			"title": title,
			"contexts": ["selection","editable"],
			"onclick": prefEnDe ? handleClickEnDe : prefFrDe ? handleClickFrDe : prefEsDe ? handleClickEsDe : prefItDe ? handleClickItDe : prefZhDe ? handleClickZhDe : prefRuDe ? handleClickRuDe : prefPtDe ? handleClickPtDe : prefPlDe ? handleClickPlDe : handleClickEnDe
		});
	}
	else if (count > 1) {
		leoContextMenu = chrome.contextMenus.create({
			"title": chrome.i18n.getMessage('leoOrgContext_label'),
			"contexts": ["selection","editable"]
		});
		if (prefEnDe) {
			var childende = chrome.contextMenus.create({
				"title": chrome.i18n.getMessage('leoOrgExt_ende_label'),
				"parentId": leoContextMenu,
				"onclick": handleClickEnDe,
				"contexts": ["selection","editable"]
			});
		}
		if (prefFrDe) {
			var childfrde = chrome.contextMenus.create({
				"title": chrome.i18n.getMessage('leoOrgExt_frde_label'),
				"parentId": leoContextMenu,
				"onclick": handleClickFrDe,
				"contexts": ["selection","editable"]
			});
		}
		if (prefEsDe) {
			var childfrde = chrome.contextMenus.create({
				"title": chrome.i18n.getMessage('leoOrgExt_esde_label'),
				"parentId": leoContextMenu,
				"onclick": handleClickEsDe,
				"contexts": ["selection","editable"]
			});
		}
		if (prefItDe) {
			var childfrde = chrome.contextMenus.create({
				"title": chrome.i18n.getMessage('leoOrgExt_itde_label'),
				"parentId": leoContextMenu,
				"onclick": handleClickItDe,
				"contexts": ["selection","editable"]
			});
		}
		if (prefZhDe) {
			var childfrde = chrome.contextMenus.create({
				"title": chrome.i18n.getMessage('leoOrgExt_zhde_label'),
				"parentId": leoContextMenu,
				"onclick": handleClickZhDe,
				"contexts": ["selection","editable"]
			});
		}
		if (prefRuDe) {
			var childfrde = chrome.contextMenus.create({
				"title": chrome.i18n.getMessage('leoOrgExt_rude_label'),
				"parentId": leoContextMenu,
				"onclick": handleClickRuDe,
				"contexts": ["selection","editable"]
			});
		}
		if (prefPtDe) {
			var childfrde = chrome.contextMenus.create({
				"title": chrome.i18n.getMessage('leoOrgExt_ptde_label'),
				"parentId": leoContextMenu,
				"onclick": handleClickPtDe,
				"contexts": ["selection","editable"]
			});
		}
		if (prefPlDe) {
			var childfrde = chrome.contextMenus.create({
				"title": chrome.i18n.getMessage('leoOrgExt_plde_label'),
				"parentId": leoContextMenu,
				"onclick": handleClickPlDe,
				"contexts": ["selection","editable"]
			});
		}
	}
});
