 // Saves options to chrome.storage
function save_options(changedElem) {
// 	console.log(changedElem.parentNode.parentNode.querySelector('span[data-dz-ui="changed"]'));
	var language = document.getElementById('language').value;
	
	var searchBehaviour;
	var searchBehaviours = document.getElementsByName('searchBehaviour');
	for (var i = 0; i < searchBehaviours.length; i++) {
		if (searchBehaviours[i].checked) {
			searchBehaviour = searchBehaviours[i].value;
			break;
		}
	}
	
	var reUseWindow;
	reUseWindows = document.getElementsByName('reUseWindow');
	for (var i = 0; i < reUseWindows.length; i++) {
		if (reUseWindows[i].checked) {
			reUseWindow = reUseWindows[i].value;
			break;
		}
	}
	
	var prefEnDe;
	prefEnDe = (document.getElementById('prefEnDe').checked) ? 1 : 0;
	var prefFrDe;
	prefFrDe = (document.getElementById('prefFrDe').checked) ? 1 : 0;
	var prefEsDe;
	prefEsDe = (document.getElementById('prefEsDe').checked) ? 1 : 0;
	var prefItDe;
	prefItDe = (document.getElementById('prefItDe').checked) ? 1 : 0;
	var prefZhDe;
	prefZhDe = (document.getElementById('prefZhDe').checked) ? 1 : 0;
	var prefRuDe;
	prefRuDe = (document.getElementById('prefRuDe').checked) ? 1 : 0;
	var prefPtDe;
	prefPtDe = (document.getElementById('prefPtDe').checked) ? 1 : 0;
	var prefPlDe;
	prefPlDe = (document.getElementById('prefPlDe').checked) ? 1 : 0;
	
	chrome.storage.local.set({
		language: language,
		searchBehaviour: searchBehaviour,
		reUseWindow: reUseWindow,
		prefEnDe: prefEnDe,
		prefFrDe: prefFrDe,
		prefEsDe: prefEsDe,
		prefItDe: prefItDe,
		prefZhDe: prefZhDe,
		prefRuDe: prefRuDe,
		prefPtDe: prefPtDe,
		prefPlDe: prefPlDe,
	}, function() {
		// Reload the add-on:
		chrome.runtime.reload();
		// Update status to let user know options were saved.
		var status = document.getElementById('status');
		status.textContent = 'Options saved.';
		setTimeout(function() {
			status.textContent = '';
		}, 2500);
	});
}
 
// Restores select box and checkbox state using the preferences
// stored in chrome.storage.
function restore_options() {
	chrome.storage.local.get({
		language: 'de',
		searchBehaviour: 1,
		reUseWindow: 1,
		prefEnDe: true,
		prefFrDe: true,
		prefEsDe: true,
		prefItDe: true,
		prefZhDe: true,
		prefRuDe: true,
		prefPtDe: true,
		prefPlDe: true
	}, function(items) {
		document.getElementById('language').value = items.language;
		var searchBehaviours = document.getElementsByName('searchBehaviour');
		for (var i = 0; i < searchBehaviours.length; i++) {
			if (searchBehaviours[i].value == items.searchBehaviour) {
				searchBehaviours[i].checked = true;
				break;
			}
		}
		var reUseWindows = document.getElementsByName('reUseWindow');
		for (var i = 0; i < reUseWindows.length; i++) {
			if (reUseWindows[i].value == items.reUseWindow) {
				reUseWindows[i].checked = true;
				break;
			}
		}
		document.getElementById('prefEnDe').checked = items.prefEnDe;
		document.getElementById('prefFrDe').checked = items.prefFrDe;
		document.getElementById('prefEsDe').checked = items.prefEsDe;
		document.getElementById('prefItDe').checked = items.prefItDe;
		document.getElementById('prefZhDe').checked = items.prefZhDe;
		document.getElementById('prefRuDe').checked = items.prefRuDe;
		document.getElementById('prefPtDe').checked = items.prefPtDe;
		document.getElementById('prefPlDe').checked = items.prefPlDe;
		
		if (items.searchBehaviour == 1) {
			document.getElementById('leoOrgPreferences_reUseWindow').setAttribute("class", "gray");
		}
	});
}
document.addEventListener('DOMContentLoaded', restore_options);
document.getElementById('savebutton').addEventListener('click', save_options);

var inputs = document.getElementsByName("input");
for (var i = 0; i < inputs.length; i++) {
	inputs[i].addEventListener('click', save_options(inputs[i]));
}
